public class Graphe{

    int NS; //nombre de sommets 
    int[][] dico; //dico qui contient les successeurs
    int NA; // nombre d'arcs
    int[] orig; //tableau pour les origines des arcs
    int[] extr; //tableau pour les extrémités des arcs


    //constructeur à partir du dictionnaire
    Graphe(int dico[][]){
	this.dico = dico;
	this.NS = dico.length;
	initialiseNA();
	initialiseArcs();
    }

    //constructeur à partir des arcs
    Graphe(int NS, int[] orig, int[] extr){
	this.NS = NS;
	this.orig = orig;
	this.extr=extr;
	this.NA = orig.length;
	initialiseDico();
    }

    //affiche les successeurs du sommet s
    void afficheSuccesseurs(int s){
	System.out.print(s+" : ");
	for (int i =0; i<dico[s-1].length;i++){
	    System.out.print(dico[s-1][i]+" ");
	}
	System.out.println();
    }

    //affiche le graphe
    void affiche(){
	//affiche le dico
	System.out.println("Dictionnaire du graphe :");
	for (int i =0; i<NS; i++){
	    afficheSuccesseurs(i+1);
	}
	//affiche les tableaux représentants les arcs
	System.out.println();
	System.out.println("Arcs :");

	for (int i=0; i<NA;i++){
	    System.out.print(orig[i]+" | ");
	}
	System.out.println();
	for (int i=0; i<NA;i++){
	    System.out.print(extr[i]+" | ");
	}
	System.out.println();
    }

    //affiche les prédécesseurs du sommet s
    void affichePredecesseurs(int s){
	System.out.print("Prédécesseurs de "+s+ " : ");
	for (int i = 0; i< NS; i++){
	    for (int j =0; j< dico[i].length;j++){
		if (dico[i][j]==s){
		    System.out.print((i+1)+" ");
		    break;
		}
	    }
	}
	System.out.println();
    }

    //initialise NA à partir de t
    void initialiseNA(){
	NA = 0;
	for(int i = 0; i< NS; i++){
	    NA = NA+  dico[i].length;
	}
    }

    //initialise les tableaux orig et extr à partir de t
    void initialiseArcs(){
	orig = new int[NA];
	extr = new int[NA];
	int k =0; //indice de l'arc
	for (int i = 0; i< NS; i++){
	    for (int j =0; j< dico[i].length;j++){
		orig[k] = i+1;
		extr[k]=dico[i][j];
		k++;
	    }
	}
    }

    //calcul Matrice incidence à partir des arcs
    int[][] matriceIncidence(){
	int[][] m = new int[NS][NS];
	for (int k =0; k<NA;k++){
	    m[orig[k]-1][extr[k]-1] =1;
	}
	return(m);
    }

    //intialise Dico à partir des arcs via la matrice d'incidence
    void initialiseDico(){
	dico = new int[NS][];
	int[][] m = matriceIncidence();
	int nb;
	int k;
	for(int i =0; i<NS;i++){
	    //calcul le nombre de successeurs du sommet i+1
	    nb =0;
	    for(int j = 0; j<NS;j++){
		nb = nb+m[i][j];
	    }
	    //creer la liste des successeurs du sommet i+1
	    dico[i] = new int[nb];
	    k=0;
	    for(int j = 0; j<NS;j++){
		if (m[i][j]==1){
		    dico[i][k] = j+1;
		    k++;
		}
	    }
	}
    }

    
    public static void main(String[] arg){
	System.out.println("Graphe du TD");
	int [][] dico={{2,4,5}, {4,6}, {5,6},{2}, {3,4,6}, {4}};
	Graphe g = new Graphe(dico);
	g.affiche();
	System.out.println();
	System.out.println("Test du second constructeur sur le même graphe");
	Graphe h = new Graphe(g.NS, g.orig, g.extr);
	h.affiche();


    }


}